{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{ 1.3}
Program TestCylinder;
Const InFileNam='cylinder.out';
      InFileNam1='cylinder.in';
Var N:INteger;
Type PQueen=^TQueen;
     TQueen=record
        X,Y:byte;
        next:PQueen;
        end;


Function Solvable(N,M:Byte):Boolean;
Begin
   If (M>N)
      or ((N=8) and (M=7))
      or ((N=8) and (M=8))
      or ((N=6) and (M=6))
      or ((N=4) and (M=4))
   then solvable:=false
   else solvable:=true;
End;



Procedure Insert(Var Queens:PQueen;X,Y:Byte);
Var T:PQueen;
Begin
   New(T);
   T^.X:=X;
   T^.Y:=Y;
   T^.Next:=Queens;
   Queens:=T;
End;

Procedure Destroy(Queens:PQueen);
Begin
   If Queens<>nil then begin Destroy(Queens^.Next);Dispose(Queens) end;
End;

function Attack(X,Y:BYte;Queens:PQueen):Boolean;
   function Att(X,Y,X1,Y1:shortint):Boolean;
   Begin
      Att:= (X=X1) or (Y=Y1) or (Abs(X-X1)=Abs(Y-Y1))
         or (Abs(X-N-X1)=Abs(Y-Y1)) or (Abs(X+N-X1)=Abs(Y-Y1))
   End;
Begin
   if Queens=NIl then Attack:=False
   else Attack:=Att(X,Y,Queens^.X,Queens^.Y) or Attack(X,Y,Queens^.Next)
End;

Var f:Text;
    S:String;
    Correct:Boolean;
    i,M,X,Y,M1,N1:Byte;
    Queens:Pqueen;
Begin
   Correct:=true;
   Assign(f,InFileNam1);
   reset(f);
   readln(f,N1,M1);
   close(f);
   Assign(f,InFileNam);
   reset(f);
   readln(f,N,M);
   Correct:=(N=N1) and (M=M1);
   if Solvable(N,M) then
   begin
      i:=1;
      Queens:=nil;
      while Correct and {(i<=M) and} Not EOF(f) do
      begin
         readln(f,X,Y);
         Correct:=(X in [1..N]) and (Y in [1..N]) and (NOt Attack(X,Y,Queens));
         if Correct then insert(Queens,X,Y);
         inc(i);
      end;
      destroy(Queens);
      Correct:=Correct and (i=M+1);
   end
   else {Not Solvable(N,M)}
   begin
      readln(f,X,Y);
      Correct:=Correct and (X=0) and (Y=0);
   end;
   close(f);
   writeln(Correct);
   IF Correct then halt(5) else halt(0);
end.